//TestTelli2cFonc.ino
// We define functions for the most frequent situations 
// No need to put a delay after SendMode(). Just to show you 

#include <Wire.h>

#define Adi2c 0x20  // 7-bit address
void Send16 (int hl) {
  Wire.beginTransmission(Adi2c); 
  Wire.write(hl>>8);  
  Wire.write(hl&0xFF);     
  Wire.endTransmission();   
}

void Sendhl (int hl) {
  Wire.beginTransmission(Adi2c); 
  Wire.write(hl<<8);  
  Wire.write(hl&0xFF);     
  Wire.endTransmission();   
}

void SendText (char aa, char bb, char cc, char dd) {
  Wire.beginTransmission(Adi2c); 
  Wire.write(aa);  
  Wire.write(bb); 
  Wire.write(cc);   
  Wire.write(dd);     
  Wire.endTransmission(); 
}

void SendModes (byte dd, byte ss) {
  Wire.beginTransmission(Adi2c); 
  Wire.write(dd);  
  Wire.write(ss); 
  Wire.write(0);   
  Wire.write(0);   
  Wire.write(0);    
  Wire.endTransmission();
}


#define bPulse 0
#define Pulse  (!(PINC&(1<<bPulse)))
void WaitPulse() {
  while (!Pulse) {delay(20);}
  while (Pulse) {delay(20);}
}

#define wt WaitPulse()  // delay between transfers

void setup() {
  Wire.begin(); 
}

int time;

void loop() {
delay (200);
  SendModes (0,0);
 wt;
  Send16 (0x270F);
 wt;

  SendModes (1,0);
 wt;
  Send16 (0x270F);
 wt;
  Send16 (9999);
 wt;

  SendText (0x41,'b',67,'D');
 wt;

  char c, d ='a';
  for (byte i=0; i<6; i++) { 
    c=d++;
    SendText (c++,c++,c++,c);
    delay (200);
  }
 wt;
 char text [] = {'abcdDgTelli2c...'};
 char tex [] = "abcdDgTelli2c...";
   for (byte i=0; i<10; i++) { 
     SendText (tex [i],tex [i+1],tex [i+2],tex [i+3]);
    delay (200);
  }
 wt;

  SendText ('v','o','l','t');
 wt; 
  Send16 (510);
 wt; 
  SendModes (0,0);
  
  SendText ('t'+128,'i'+128,'m'+128,'e'+128);
 wt; 
  Send16 (time++);
 wt;

  SendModes (0,1);  // segment
 wt;

  SendText (57,9,9,15);
  delay (2000);
 wt;
}



